/**
* WebViewer3D provides an HTML5-based 3D viewing component
*
* @module WebViewer3D
* @author DOGO, PHST
* @copyright	2014 Esko Stonecube Ltd. All rights reserved.
* @version  0.7.1
*/

define(["WV3Dmod/ViewerController","WV3Dmod/Constants","WV3Dmod/LogMessage","WV3D/BuildVersion"],function(h,a,f,g){a=function(d,c,a,e){console.log("ESKO HTML Viewer - Client V"+g.SuiteNumber+"/"+g.P4VChangelistNumber);f.SetCallbackFunction(e);f.Log("Creating WebViewer3DAPI Object");this._controller=new h(d,c,a)};a.prototype.Dispose=function(){f.Log("API Dispose");this._controller.Dispose()};a.prototype.SetLogMessageCallback=function(d){f.SetCallbackFunction(d)};a.prototype.SetEndCameraInteractionCallback=
function(d){this._controller.SetEndCameraInteractionCallback(d)};a.prototype.Resize=function(){this._controller.get("_view").Resize()};a.prototype.Initialize=function(){f.Log("Initialize: Deprecated API function !!!!!!!!!!!!!!!! (No need to call that function anymore)")};a.prototype.LoadScene=function(d,a,b,e){f.Log("API Load Scene from URL");this._controller.LoadSceneFromURL(d,a,b,e)};a.prototype.LoadSceneFromLocalFile=function(d,a,b,e){f.Log("API Load Scene from local file");var i=new FileReader,
j=this;i.onload=function(){j.LoadSceneFromObject(JSON.parse(i.result),a,b,e)};i.readAsText(d)};a.prototype.LoadSceneFromObject=function(d,a,b,e){f.Log("API Load Scene from object");this._controller.LoadSceneFromJSONObject(d,a,b,e)};a.prototype.ResetMainSceneVisibility=function(){f.Log("API Reset visiblity of main scene: ");this._controller.ResetMainSceneVisibility()};a.prototype.ToggleNodeVisibility=function(d,a,b){this._controller.ToggleNodeVisibility(d,a,b)};a.prototype.SetNodeVisibility=function(d,
a,b,e){this._controller.SetNodeVisibility(d,a,b,e)};a.prototype.SetCameraAngles=function(d,a,b){this._controller.SetCameraAngles(d,a,b)};a.prototype.GetCameraAngles=function(){return this._controller.GetCameraAngles()};a.prototype.ResetCamera=function(){this._controller.ResetCamera()};a.prototype.ToggleInteractiveCameraControl=function(d){this._controller.SetInteractiveCameraControl(d)};a.prototype.SetInteractiveCameraControlMask=function(d){this._controller.SetInteractiveCameraControlMask(d)};a.prototype.SetCameraScale=
function(d,a){this._controller.SetCameraScale(d,a)};a.prototype.GetCameraScale=function(){return this._controller.GetCameraScale()};a.prototype.SetCameraPanOffset=function(a,c,b){this._controller.SetCameraPanOffset(a,c,b)};a.prototype.GetCameraPanOffset=function(){return this._controller.GetCameraPanOffset()};a.prototype.SetEnvironmentRotation=function(a,c){this._controller.SetEnvironmentRotation(a,c)};a.prototype.GetEnvironmentRotation=function(){return this._controller.GetEnvironmentRotation()};
a.prototype.GetOptimisedScaleForCurrentView=function(a,c,b){return this._controller.GetOptimisedScaleForCurrentView(a,c,b)};a.prototype.SetOptimisedViewRendering=function(a,c,b){this._controller.SetOptimisedViewRendering(a,c,b)};a.prototype.SetPerspectiveCamera=function(a,c){this._controller.SetPerspectiveCamera(a,c)};a.prototype.SetOrthographicCamera=function(a){this._controller.SetOrthographicCamera(a)};a.prototype.SetCameraFocus=function(a,c){this._controller.SetCameraFocus(a,c)};a.prototype.SetHighlights=
function(a,c){this._controller.SetHighlights(a,c)};a.prototype.SetHighlightsConfiguration=function(a,c,b){this._controller.SetHighlightsConfiguration(a,c,b)};a.prototype.SetHighlightsColor=function(a,c,b,e){this._controller.SetHighlightsColor(parseFloat(a),parseFloat(c),parseFloat(b),e)};a.prototype.SetBackgroundColor=function(a,c,b,e,f){this._controller.SetBackgroundColor(parseFloat(a),parseFloat(c),parseFloat(b),parseFloat(e),f)};a.prototype.SetLabelsVisibility=function(a,c,b,e){this._controller.SetLabelsVisibility(a,
c,b,e)};a.prototype.SetLabelText=function(a,c,b){this._controller.SetLabelText(a,c,b)};a.prototype.SetLabelsParameters=function(a){this._controller.SetLabelsParameters(JSON.parse(a))};a.prototype.SetDimensionsVisibility=function(a,c,b,e,f,j,g,h,k){this._controller.SetDimensionsVisibility(a,c,parseFloat(b),e,parseFloat(f),j,parseFloat(g),h,k,!0)};a.prototype.SetDimensionsParameters=function(a){this._controller.SetDimensionsParameters(JSON.parse(a))};a.prototype.GetSystemSupportLevel=function(){return this._controller.GetSystemSupportLevel()};
a.prototype.GetSystemReport=function(){return this._controller.GetSystemReport()};a.prototype.GetSnapshot=function(a,c,b){return this._controller.GetSnapshot(a,c,b)};return a});