/**
 * @author DOGO, parts taken from alteredq (http://alteredqualia.com/)
 * @module WebViewer3D
 * @copyright   2015 Esko Stonecube Ltd. All rights reserved.
 */

define(["WV3Dlib/three","backbone","WV3Dmod/shaders/CopyShader"],function(b,j,h){return j.Model.extend({initialize:function(){b.Object3D.prototype.traverseParents=function(a){a(this);this.parent&&this.parent.traverseParents(a)};b.ShaderPass=function(a,e){this.textureID=void 0!==e?e:"tDiffuse";this.uniforms=b.UniformsUtils.clone(a.uniforms);this.material=new b.ShaderMaterial({uniforms:this.uniforms,vertexShader:a.vertexShader,fragmentShader:a.fragmentShader});this.renderToScreen=!1;this.needsSwap=
this.enabled=!0;this.clear=!1};b.ShaderPass.prototype={render:function(a,e,f){this.uniforms[this.textureID]&&(this.uniforms[this.textureID].value=f);b.EffectComposer.quad.material=this.material;this.renderToScreen?a.render(b.EffectComposer.scene,b.EffectComposer.camera):a.render(b.EffectComposer.scene,b.EffectComposer.camera,e,this.clear)}};b.EffectComposer=function(a,e){this.renderer=a;void 0===e&&(e=new b.WebGLRenderTarget(window.innerWidth||1,window.innerHeight||1,{minFilter:b.LinearFilter,magFilter:b.LinearFilter,
format:b.RGBFormat,stencilBuffer:!1}));this.renderTarget1=e;this.renderTarget2=e.clone();this.writeBuffer=this.renderTarget1;this.readBuffer=this.renderTarget2;this.passes=[];void 0===h&&console.error("THREE.EffectComposer relies on CopyShader");this.copyPass=new b.ShaderPass(h)};b.EffectComposer.prototype={swapBuffers:function(){var a=this.readBuffer;this.readBuffer=this.writeBuffer;this.writeBuffer=a},addPass:function(a){this.passes.push(a)},insertPass:function(a,b){this.passes.splice(b,0,a)},render:function(a,
e,f){this.writeBuffer=this.renderTarget1;this.readBuffer=this.renderTarget2;var c=!1,d,g,h=this.passes.length;for(g=0;g<h;g++)if(d=this.passes[g],e&&(d.scene=e),f&&(d.camera=f),d.enabled){d.render(this.renderer,this.writeBuffer,this.readBuffer,a,c);this.renderer.autoClear=!1;if(d.needsSwap){if(c){var i=this.renderer.context;i.stencilFunc(i.NOTEQUAL,1,4294967295);this.copyPass.render(this.renderer,this.writeBuffer,this.readBuffer,a);i.stencilFunc(i.EQUAL,1,4294967295)}this.swapBuffers()}d instanceof
b.MaskPass?c=!0:d instanceof b.ClearMaskPass&&(c=!1)}},reset:function(a){void 0===a&&(a=this.renderTarget1.clone(),a.width=window.innerWidth,a.height=window.innerHeight);this.renderTarget1=a;this.renderTarget2=a.clone();this.writeBuffer=this.renderTarget1;this.readBuffer=this.renderTarget2},setSize:function(a,b){var f=this.renderTarget1.clone();f.width=a;f.height=b;this.reset(f)}};b.EffectComposer.camera=new b.OrthographicCamera(-1,1,1,-1,0,1);b.EffectComposer.quad=new b.Mesh(new b.PlaneGeometry(2,
2),null);b.EffectComposer.scene=new b.Scene;b.EffectComposer.scene.add(b.EffectComposer.quad);b.RenderPass=function(a,e,f,c,d){this.scene=a;this.camera=e;this.overrideMaterial=f;this.clearColor=c;this.clearAlpha=void 0!==d?d:1;this.oldClearColor=new b.Color;this.oldClearAlpha=1;this.clear=this.enabled=!0;this.needsSwap=!1};b.RenderPass.prototype={render:function(a,b,f){this.scene.overrideMaterial=this.overrideMaterial;this.clearColor&&(this.oldClearColor.copy(a.getClearColor()),this.oldClearAlpha=
a.getClearAlpha(),a.setClearColor(this.clearColor,this.clearAlpha));a.render(this.scene,this.camera,f,this.clear);this.clearColor&&a.setClearColor(this.oldClearColor,this.oldClearAlpha);this.scene.overrideMaterial=null}};b.MaskPass=function(a,b){this.scene=a;this.camera=b;this.clear=this.enabled=!0;this.inverse=this.needsSwap=!1};b.MaskPass.prototype={render:function(a,b,f){var c=a.context;c.colorMask(!1,!1,!1,!1);c.depthMask(!1);var d,g;this.inverse?(d=0,g=1):(d=1,g=0);c.enable(c.STENCIL_TEST);c.stencilOp(c.REPLACE,
c.REPLACE,c.REPLACE);c.stencilFunc(c.ALWAYS,d,4294967295);c.clearStencil(g);a.render(this.scene,this.camera,f,this.clear);a.render(this.scene,this.camera,b,this.clear);c.colorMask(!0,!0,!0,!0);c.depthMask(!0);c.stencilFunc(c.EQUAL,1,4294967295);c.stencilOp(c.KEEP,c.KEEP,c.KEEP)}};b.ClearMaskPass=function(){this.enabled=!0};b.ClearMaskPass.prototype={render:function(a){a=a.context;a.disable(a.STENCIL_TEST)}}}})});