/**
 * Copyright (c) 2009-2013 Jeremy Ashkenas
 * 
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 * 
 */

define(["require","exports","module"],function(o,d){var l,i,m,j,k,n;d.starts=function(a,b,c){return b===a.substr(c,b.length)};d.ends=function(a,b,c){var e;e=b.length;return b===a.substr(a.length-e-(c||0),e)};d.repeat=j=function(a,b){var c;for(c="";0<b;)b&1&&(c+=a),b>>>=1,a+=a;return c};d.compact=function(a){var b,c,e,d;d=[];c=0;for(e=a.length;c<e;c++)(b=a[c])&&d.push(b);return d};d.count=function(a,b){var c,e;c=e=0;if(!b.length)return 1/0;for(;e=1+a.indexOf(b,e);)c++;return c};d.merge=function(a,
b){return i(i({},a),b)};i=d.extend=function(a,b){var c,e;for(c in b)e=b[c],a[c]=e;return a};d.flatten=m=function(a){var b,c,e,d;c=[];e=0;for(d=a.length;e<d;e++)b=a[e],b instanceof Array?c=c.concat(m(b)):c.push(b);return c};d.del=function(a,b){var c;c=a[b];delete a[b];return c};d.last=function(a,b){return a[a.length-(b||0)-1]};d.some=null!=(n=Array.prototype.some)?n:function(a){var b,c,e;c=0;for(e=this.length;c<e;c++)if(b=this[c],a(b))return!0;return!1};d.invertLiterate=function(a){var b;b=!0;var c,
e,d,f;d=a.split("\n");f=[];c=0;for(e=d.length;c<e;c++)a=d[c],b&&/^([ ]{4}|[ ]{0,3}\t)/.test(a)?f.push(a):(b=/^\s*$/.test(a))?f.push(a):f.push("# "+a);return f.join("\n")};l=function(a,b){return b?{first_line:a.first_line,first_column:a.first_column,last_line:b.last_line,last_column:b.last_column}:a};d.addLocationDataFn=function(a,b){return function(c){"object"===typeof c&&c.updateLocationDataIfMissing&&c.updateLocationDataIfMissing(l(a,b));return c}};d.locationDataToString=function(a){var b;"2"in
a&&"first_line"in a[2]?b=a[2]:"first_line"in a&&(b=a);return b?""+(b.first_line+1)+":"+(b.first_column+1)+"-"+(""+(b.last_line+1)+":"+(b.last_column+1)):"No location data"};d.baseFileName=function(a,b,c){null==b&&(b=!1);null==c&&(c=!1);a=a.split(c?/\\|\//:/\//);a=a[a.length-1];if(!(b&&0<=a.indexOf(".")))return a;a=a.split(".");a.pop();"coffee"===a[a.length-1]&&1<a.length&&a.pop();return a.join(".")};d.isCoffee=function(a){return/\.((lit)?coffee|coffee\.md)$/.test(a)};d.isLiterate=function(a){return/\.(litcoffee|coffee\.md)$/.test(a)};
d.throwSyntaxError=function(a,b){var c;null==b.last_line&&(b.last_line=b.first_line);null==b.last_column&&(b.last_column=b.first_column);c=new SyntaxError(a);c.location=b;c.toString=k;c.stack=c.toString();throw c;};d.updateSyntaxError=function(a,b,c){a.toString===k&&(a.code||(a.code=b),a.filename||(a.filename=c),a.stack=a.toString());return a};k=function(){var a,b,c,d,h,f,g,i;if(!this.code||!this.location)return Error.prototype.toString.call(this);a=this.location;f=a.first_line;h=a.first_column;c=
a.last_line;g=a.last_column;null==c&&(c=f);null==g&&(g=h);d=this.filename||"[stdin]";a=this.code.split("\n")[f];c=f===c?g+1:a.length;g=j(" ",h)+j("^",c-h);"undefined"!==typeof process&&null!==process&&(b=process.stdout.isTTY&&!process.env.NODE_DISABLE_COLORS);if(null!=(i=this.colorful)?i:b)b=function(a){return"\u001b[1;31m"+a+"\u001b[0m"},a=a.slice(0,h)+b(a.slice(h,c))+a.slice(c),g=b(g);return""+d+":"+(f+1)+":"+(h+1)+": error: "+this.message+"\n"+a+"\n"+g}});