/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/oop ../lib/lang ../worker/mirror ./css/csslint".split(" "),function(c,g){var h=c("../lib/oop"),i=c("../lib/lang"),d=c("../worker/mirror").Mirror,e=c("./css/csslint").CSSLint,f=g.Worker=function(a){d.call(this,a);this.setTimeout(400);this.ruleset=null;this.setDisabledRules("ids|order-alphabetical");this.setInfoRules("adjoining-classes|qualified-headings|zero-units|gradients|import|outline-none|vendor-prefix")};h.inherits(f,d);(function(){this.setInfoRules=function(a){"string"==
typeof a&&(a=a.split("|"));this.infoRules=i.arrayToMap(a);this.doc.getValue()&&this.deferredUpdate.schedule(100)};this.setDisabledRules=function(a){if(a){"string"==typeof a&&(a=a.split("|"));var b={};e.getRules().forEach(function(a){b[a.id]=!0});a.forEach(function(a){delete b[a]});this.ruleset=b}else this.ruleset=null;this.doc.getValue()&&this.deferredUpdate.schedule(100)};this.onUpdate=function(){var a=this.doc.getValue();if(!a)return this.sender.emit("csslint",[]);var b=this.infoRules,a=e.verify(a,
this.ruleset);this.sender.emit("csslint",a.messages.map(function(a){return{row:a.line-1,column:a.col-1,text:a.message,type:b[a.rule.id]?"info":a.type,rule:a.rule.name}}))}}).call(f.prototype)});