/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2012, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/oop ./html_highlight_rules ./javascript_highlight_rules ../lib/oop ./html ./javascript ./css ./ruby".split(" "),function(a,f){var c=a("../lib/oop"),g=a("./html_highlight_rules").HtmlHighlightRules,j=a("./javascript_highlight_rules").JavaScriptHighlightRules,d=function(a,b){g.call(this);a||(a="(?:<%|<\\?|{{)");b||(b="(?:%>|\\?>|}})");for(var c in this.$rules)this.$rules[c].unshift({token:"markup.list.meta.tag",regex:a+"(?![>}])[-=]?",push:"ejs-start"});this.embedRules(j,
"ejs-");this.$rules["ejs-start"].unshift({token:"markup.list.meta.tag",regex:"-?"+b,next:"pop"},{token:"comment",regex:"//.*?"+b,next:"pop"});this.$rules["ejs-no_regex"].unshift({token:"markup.list.meta.tag",regex:"-?"+b,next:"pop"},{token:"comment",regex:"//.*?"+b,next:"pop"});this.normalizeRules()};c.inherits(d,g);f.EjsHighlightRules=d;var c=a("../lib/oop"),h=a("./html").Mode,i=a("./javascript").Mode,k=a("./css").Mode;a("./ruby");var e=function(){h.call(this);this.HighlightRules=d;this.createModeDelegates({"js-":i,
"css-":k,"ejs-":i})};c.inherits(e,h);(function(){this.$id="ace/mode/ejs"}).call(e.prototype);f.Mode=e});