/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2012, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/oop ./text ./logiql_highlight_rules ./folding/coffee ../token_iterator ../range ./behaviour/cstyle ./matching_brace_outdent".split(" "),function(e,i){var j=e("../lib/oop"),k=e("./text").Mode,l=e("./logiql_highlight_rules").LogiQLHighlightRules,m=e("./folding/coffee").FoldMode,g=e("../token_iterator").TokenIterator,h=e("../range").Range,n=e("./behaviour/cstyle").CstyleBehaviour,o=e("./matching_brace_outdent").MatchingBraceOutdent,f=function(){this.HighlightRules=
l;this.foldingRules=new m;this.$outdent=new o;this.$behaviour=new n};j.inherits(f,k);(function(){this.lineCommentStart="//";this.blockComment={start:"/*",end:"*/"};this.getNextLineIndent=function(b,a,d){var c=this.$getIndent(a),b=this.getTokenizer().getLineTokens(a,b),e=b.tokens;if(/comment|string/.test(b.state)||e.length&&"comment.single"==e[e.length-1].type)return c;a.match();/(--\>|<--|<-|->|{)\s*$/.test(a)&&(c+=d);return c};this.checkOutdent=function(b,a,d){return this.$outdent.checkOutdent(a,
d)?!0:"\n"!==d&&"\r\n"!==d||!/^\s+/.test(a)?!1:!0};this.autoOutdent=function(b,a,d){if(!this.$outdent.autoOutdent(a,d)){var c=a.getLine(d),b=c.match(/^\s+/),c=c.lastIndexOf(".")+1;if(!b||!d||!c)return 0;a.getLine(d+1);var e=this.getMatching(a,{row:d,column:c});if(!e||e.start.row==d)return 0;c=b[0].length;b=this.$getIndent(a.getLine(e.start.row));a.replace(new h(d+1,0,d+1,c),b)}};this.getMatching=function(b,a,d){void 0==a&&(a=b.selection.lead);"object"==typeof a&&(d=a.column,a=a.row);var c=b.getTokenAt(a,
d);if(c){if("keyword.start"==c.type)a=new g(b,a,d),a.step=a.stepForward;else if("keyword.end"==c.type)a=new g(b,a,d),a.step=a.stepBackward;else return;for(;(b=a.step())&&!("keyword.start"==b.type||"keyword.end"==b.type););if(b&&b.type!=c.type)return c=a.getCurrentTokenColumn(),a=a.getCurrentTokenRow(),new h(a,c,a,c+b.value.length)}};this.$id="ace/mode/logiql"}).call(f.prototype);i.Mode=f});