/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&require("amd-loader");
define(["require","exports","module","../../test/assertions","../coffee/coffee-script"],function(e,h,g){function c(a,c,d,e,f){b.equal(a.location.first_line,c);b.equal(a.location.first_column,d);b.equal(a.location.last_line,e);b.equal(a.location.last_column,f)}function d(a){try{f.parse(a).compile()}catch(b){return b}}var b=e("../../test/assertions"),f=e("../coffee/coffee-script");g.exports={"test parse valid coffee script":function(){f.parse("square = (x) -> x * x")},"test parse invalid coffee script":function(){var a=
d("a = 12 f");b.equal(a.message,"Unexpected 'IDENTIFIER'");c(a,0,4,0,5)},"test parse missing bracket":function(){var a=d("a = 12 f {\n\n");b.equal(a.message,"missing }");c(a,0,10,0,10)},"test unexpected indent":function(){var a=d("a\n  a\n");b.equal(a.message,"Unexpected 'INDENT'");c(a,1,0,1,1)},"test invalid destructuring":function(){var a=d("\n{b: 5} = {}");b.equal(a.message,'"5" cannot be assigned');c(a,1,4,1,4)}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();