/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/oop ./text ./css_highlight_rules ./matching_brace_outdent ../worker/worker_client ./behaviour/css ./folding/cstyle".split(" "),function(a,f){var g=a("../lib/oop"),h=a("./text").Mode,i=a("./css_highlight_rules").CssHighlightRules,j=a("./matching_brace_outdent").MatchingBraceOutdent,k=a("../worker/worker_client").WorkerClient,l=a("./behaviour/css").CssBehaviour,m=a("./folding/cstyle").FoldMode,d=function(){this.HighlightRules=i;this.$outdent=new j;this.$behaviour=
new l;this.foldingRules=new m};g.inherits(d,h);(function(){this.foldingRules="cStyle";this.blockComment={start:"/*",end:"*/"};this.getNextLineIndent=function(c,b,a){var e=this.$getIndent(b),c=this.getTokenizer().getLineTokens(b,c).tokens;if(c.length&&"comment"==c[c.length-1].type)return e;b.match(/^.*\{\s*$/)&&(e+=a);return e};this.checkOutdent=function(c,b,a){return this.$outdent.checkOutdent(b,a)};this.autoOutdent=function(a,b,d){this.$outdent.autoOutdent(b,d)};this.createWorker=function(a){var b=
new k(["ace"],"ace/mode/css_worker","Worker");b.attachToDocument(a.getDocument());b.on("csslint",function(b){a.setAnnotations(b.data)});b.on("terminate",function(){a.clearAnnotations()});return b};this.$id="ace/mode/css"}).call(d.prototype);f.Mode=d});