/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../../lib/oop ../../range ./cstyle".split(" "),function(e,k){var l=e("../../lib/oop"),j=e("../../range").Range,m=e("./cstyle").FoldMode,h=k.FoldMode=function(a){a&&(this.foldingStartMarker=RegExp(this.foldingStartMarker.source.replace(/\|[^|]*?$/,"|"+a.start)),this.foldingStopMarker=RegExp(this.foldingStopMarker.source.replace(/\|[^|]*?$/,"|"+a.end)))};l.inherits(h,m);(function(){this.usingRe=/^\s*using \S/;this.getFoldWidgetRangeBase=this.getFoldWidgetRange;this.getFoldWidgetBase=
this.getFoldWidget;this.getFoldWidget=function(a,b,c){b=this.getFoldWidgetBase(a,b,c);if(!b){var d=a.getLine(c);if(/^\s*#region\b/.test(d))return"start";var f=this.usingRe;if(f.test(d)&&(d=a.getLine(c-1),a=a.getLine(c+1),!f.test(d)&&f.test(a)))return"start"}return b};this.getFoldWidgetRange=function(a,b,c){if(b=this.getFoldWidgetRangeBase(a,b,c))return b;b=a.getLine(c);if(this.usingRe.test(b))return this.getUsingStatementBlock(a,b,c);if(/^\s*#region\b/.test(b))return this.getRegionBlock(a,b,c)};this.getUsingStatementBlock=
function(a,b,c){for(var d=b.match(this.usingRe)[0].length-1,f=a.getLength(),i=c,g=c;++c<f;)if(b=a.getLine(c),!/^\s*$/.test(b)){if(!this.usingRe.test(b))break;g=c}if(g>i)return a=a.getLine(g).length,new j(i,d,g,a)};this.getRegionBlock=function(a,b,c){for(var d=b.search(/\s*$/),f=a.getLength(),i=c,g=/^\s*#(end)?region\b/,e=1;++c<f;){var b=a.getLine(c),h=g.exec(b);if(h&&(h[1]?e--:e++,!e))break}a=c;if(a>i)return new j(i,d,a,b.length)}}).call(h.prototype)});