/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2012, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../../lib/oop ./fold_mode ../../range ../../token_iterator".split(" "),function(h,k){var l=h("../../lib/oop"),m=h("./fold_mode").FoldMode,j=h("../../range").Range,n=h("../../token_iterator").TokenIterator,i=k.FoldMode=function(){};l.inherits(i,m);(function(){this.foldingStartMarker=/\b(function|then|do|repeat)\b|{\s*$|(\[=*\[)/;this.foldingStopMarker=/\bend\b|^\s*}|\]=*\]/;this.getFoldWidget=function(d,e,a){var b=d.getLine(a),f=this.foldingStartMarker.test(b),g=this.foldingStopMarker.test(b);
if(f&&!g){var c=b.match(this.foldingStartMarker);if("then"==c[1]&&/\belseif\b/.test(b))return;if(c[1]){if("keyword"===d.getTokenAt(a,c.index+1).type)return"start"}else if(c[2]){if(c=d.bgTokenizer.getState(a)||"","bracketedComment"==c[0]||"bracketedString"==c[0])return"start"}else return"start"}if("markbeginend"!=e||!g||f&&g)return"";c=b.match(this.foldingStopMarker);if("end"===c[0]){if("keyword"===d.getTokenAt(a,c.index+1).type)return"end"}else if("]"===c[0][0]){if(c=d.bgTokenizer.getState(a-1)||
"","bracketedComment"==c[0]||"bracketedString"==c[0])return"end"}else return"end"};this.getFoldWidgetRange=function(d,e,a){var e=d.doc.getLine(a),b=this.foldingStartMarker.exec(e);if(b)return b[1]?this.luaBlock(d,a,b.index+1):b[2]?d.getCommentFoldRange(a,b.index+1):this.openingBracketBlock(d,"{",a,b.index);if(b=this.foldingStopMarker.exec(e))return"end"===b[0]&&"keyword"===d.getTokenAt(a,b.index+1).type?this.luaBlock(d,a,b.index+1):"]"===b[0][0]?d.getCommentFoldRange(a,b.index+1):this.closingBracketBlock(d,
"}",a,b.index+b[0].length)};this.luaBlock=function(d,e,a){var a=new n(d,e,a),b={"function":1,"do":1,then:1,elseif:-1,end:-1,repeat:1,until:-1},f=a.getCurrentToken();if(f&&"keyword"==f.type){var f=f.value,g=[f],c=b[f];if(c){var h=-1===c?a.getCurrentTokenColumn():d.getLine(e).length,i=e;for(a.step=-1===c?a.stepBackward:a.stepForward;f=a.step();)if("keyword"===f.type)if(e=c*b[f.value],0<e)g.unshift(f.value);else if(0>=e){g.shift();if(!g.length&&"elseif"!=f.value)break;0===e&&g.unshift(f.value)}e=a.getCurrentTokenRow();
return-1===c?new j(e,d.getLine(e).length,i,h):new j(i,h,e,a.getCurrentTokenColumn())}}}}).call(i.prototype)});