/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&require("amd-loader");
define("require exports module ../edit_session ../tokenizer ./xml ../test/assertions".split(" "),function(c,h,d){var e=c("../edit_session").EditSession,f=c("../tokenizer").Tokenizer,g=c("./xml").Mode,b=c("../test/assertions");d.exports={setUp:function(){this.mode=new g},"test: getTokenizer() (smoke test)":function(){var a=this.mode.getTokenizer();b.ok(a instanceof f);a=a.getLineTokens("<juhu>","start").tokens;b.equal("meta.tag.punctuation.tag-open.xml",a[0].type)},"test: toggle comment lines should not do anything":function(){var a=
new e(["    abc","  cde","fg"]);this.mode.toggleCommentLines("start",a,0,1);b.equal("  <\!--  abc--\>\n  <\!--cde--\>\nfg",a.toString())},"test: next line indent should be the same as the current line indent":function(){b.equal("     ",this.mode.getNextLineIndent("start","     abc"));b.equal("",this.mode.getNextLineIndent("start","abc"));b.equal("\t",this.mode.getNextLineIndent("start","\tabc"))}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();