/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ./range ./lib/event_emitter ./lib/oop".split(" "),function(i,k){var h=i("./range").Range,l=i("./lib/event_emitter").EventEmitter,m=i("./lib/oop"),j=function(a,b,c,d,e,g){var f=this;this.length=b;this.session=a;this.doc=a.getDocument();this.mainClass=e;this.othersClass=g;this.$onUpdate=this.onUpdate.bind(this);this.doc.on("change",this.$onUpdate);this.$others=d;this.$onCursorChange=function(){setTimeout(function(){f.onCursorChange()})};this.$pos=c;this.$undoStackDepth=
(a.getUndoManager().$undoStack||a.getUndoManager().$undostack||{length:-1}).length;this.setup();a.selection.on("changeCursor",this.$onCursorChange)};(function(){m.implement(this,l);this.setup=function(){var a=this,b=this.doc,c=this.session,d=this.$pos;this.selectionBefore=c.selection.toJSON();c.selection.inMultiSelectMode&&c.selection.toSingleRange();this.pos=b.createAnchor(d.row,d.column);this.markerId=c.addMarker(new h(d.row,d.column,d.row,d.column+this.length),this.mainClass,null,!1);this.pos.on("change",
function(b){c.removeMarker(a.markerId);a.markerId=c.addMarker(new h(b.value.row,b.value.column,b.value.row,b.value.column+a.length),a.mainClass,null,!1)});this.others=[];this.$others.forEach(function(c){c=b.createAnchor(c.row,c.column);a.others.push(c)});c.setUndoSelect(!1)};this.showOtherMarkers=function(){if(!this.othersActive){var a=this.session,b=this;this.othersActive=!0;this.others.forEach(function(c){c.markerId=a.addMarker(new h(c.row,c.column,c.row,c.column+b.length),b.othersClass,null,!1);
c.on("change",function(d){a.removeMarker(c.markerId);c.markerId=a.addMarker(new h(d.value.row,d.value.column,d.value.row,d.value.column+b.length),b.othersClass,null,!1)})})}};this.hideOtherMarkers=function(){if(this.othersActive){this.othersActive=!1;for(var a=0;a<this.others.length;a++)this.session.removeMarker(this.others[a].markerId)}};this.onUpdate=function(a){var a=a.data,b=a.range;if(b.start.row===b.end.row&&b.start.row===this.pos.row&&!this.$updating){this.$updating=!0;var c="insertText"===
a.action?b.end.column-b.start.column:b.start.column-b.end.column;if(b.start.column>=this.pos.column&&b.start.column<=this.pos.column+this.length+1){var d=b.start.column-this.pos.column;this.length+=c;if(!this.session.$fromUndo){if("insertText"===a.action)for(var e=this.others.length-1;0<=e;e--){var g=this.others[e],f={row:g.row,column:g.column+d};g.row===b.start.row&&b.start.column<g.column&&(f.column+=c);this.doc.insert(f,a.text)}else if("removeText"===a.action)for(e=this.others.length-1;0<=e;e--)g=
this.others[e],f={row:g.row,column:g.column+d},g.row===b.start.row&&b.start.column<g.column&&(f.column+=c),this.doc.remove(new h(f.row,f.column,f.row,f.column-c));b.start.column===this.pos.column&&"insertText"===a.action?setTimeout(function(){this.pos.setPosition(this.pos.row,this.pos.column-c);for(var a=0;a<this.others.length;a++){var d=this.others[a],e=d.row,f=d.column-c;d.row===b.start.row&&b.start.column<d.column&&(f+=c);d.setPosition(e,f)}}.bind(this),0):b.start.column===this.pos.column&&"removeText"===
a.action&&setTimeout(function(){for(var a=0;a<this.others.length;a++){var d=this.others[a];d.row===b.start.row&&b.start.column<d.column&&d.setPosition(d.row,d.column-c)}}.bind(this),0)}this.pos._emit("change",{value:this.pos});for(e=0;e<this.others.length;e++)this.others[e]._emit("change",{value:this.others[e]})}this.$updating=!1}};this.onCursorChange=function(a){if(!this.$updating&&this.session){var b=this.session.selection.getCursor();b.row===this.pos.row&&b.column>=this.pos.column&&b.column<=this.pos.column+
this.length?(this.showOtherMarkers(),this._emit("cursorEnter",a)):(this.hideOtherMarkers(),this._emit("cursorLeave",a))}};this.detach=function(){this.session.removeMarker(this.markerId);this.hideOtherMarkers();this.doc.removeEventListener("change",this.$onUpdate);this.session.selection.removeEventListener("changeCursor",this.$onCursorChange);this.pos.detach();for(var a=0;a<this.others.length;a++)this.others[a].detach();this.session.setUndoSelect(!0);this.session=null};this.cancel=function(){if(-1===
this.$undoStackDepth)throw Error("Canceling placeholders only supported with undo manager attached to session.");for(var a=this.session.getUndoManager(),b=(a.$undoStack||a.$undostack).length-this.$undoStackDepth,c=0;c<b;c++)a.undo(!0);this.selectionBefore&&this.session.selection.fromJSON(this.selectionBefore)}}).call(j.prototype);k.PlaceHolder=j});